/* MChanfix -- chanfix.h
 * Copyright (C) 2004 MChanfix Development
 * $Id: chanfix.h,v 1.10 2004/09/19 05:16:12 musirc Exp $
 */

#ifndef __CHANFIX_H__
#define __CHANFIX_H__

#define SIMAXPACKET		511

#include "setup.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <strings.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/poll.h>
#include <sys/uio.h>
#include <signal.h>
#include <syslog.h>
#include <errno.h>
#include "match.h"
#include "csconfig.h"
#include "conf.h"
#include "queue.h"
#include "commands.h"
#include "misc.h"
#include "hash.h"
#include "module.h"
#include "timedcbs.h"
#include "mempool.h"

#define VERSION "MChanfix-1.0.5"

typedef struct _si_stats SI_STATS;

struct _si_stats
{
  u_int st_numclients;
  u_int st_maxclients;
  time_t st_maxclients_time;
  u_int st_numgservers;
  u_int st_maxgservers;
  time_t st_maxgservers_time;
  u_int st_nummservers;
  u_int st_maxmservers;
  time_t st_maxmservers_time;
  u_int st_serversbursting;
  u_int st_numchannels;
  u_int st_maxchannels;
  time_t st_maxchannels_time;
  u_int st_numinvis;
  u_int st_numopers;
};

#define si_ll_add_to_list(__bucket, __struct, __member) \
do { \
  (__struct) -> __member ## _prev = NULL; \
  if (((__struct) -> __member ## _next = (__bucket)) != NULL) \
      (__struct) -> __member ## _next -> __member ## _prev = (__struct); \
      (__bucket) = (__struct); \
} while(0)

#define si_ll_del_from_list(__bucket, __struct, __member) \
do { \
  if ((__struct) -> __member ## _prev) \
      (__struct) -> __member ## _prev-> __member ## _next = \
      (__struct) -> __member ## _next; \
  else \
    (__bucket) = (__struct) -> __member ## _next; \
  if ((__struct) -> __member ## _next) \
  (__struct) -> __member ## _next -> __member ## _prev = \
  (__struct) -> __member ## _prev; \
} while(0)

#define TS_CURRENT 5
#define TS_MIN 5
extern time_t Now, SIAutoconn_time;
extern SI_STATS SIStats;
extern u_int SIAutoconn_num;
extern SI_MEMPOOL SIModulePool, SIMainPool, SIConfPool, SIQueuePool;
SI_SERVERCONF *_siconf_find_server(char *, struct sockaddr_in *);
#endif
