/* MChanfix -- conf.h
 * Copyright (C) 2004 MChanfix Development
 * $Id: conf.h,v 1.2 2004/08/30 00:00:21 musirc Exp $
 */

#ifndef __CONF_H__
#define __CONF_H__

#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "hash.h"
#include "module.h"

typedef struct _si_listenconf SI_LISTENCONF;
typedef struct _si_serverconf SI_SERVERCONF;
typedef struct _si_moduleconf SI_MODULECONF;
typedef struct _si_conf	SI_CONF;

struct _si_listenconf
{
  int lc_fd;
  SI_CONN *lc_con;
  struct sockaddr_in lc_sin;
  u_int lc_flags;
  SI_CONF *lc_conf;
  SI_LISTENCONF *lc_next;
  SI_LISTENCONF *lc_prev;
};

struct _si_serverconf
{
  char *sc_name;
  char *sc_cpasswd;
  char *sc_npasswd;
#define SI_SC_FLAGS_AUTOCONN 0x001
  u_int sc_flags;
  struct sockaddr_in sc_sin;
  struct sockaddr_in sc_sin_src;
  time_t sc_tryconnecttime;
  SI_CONF *sc_conf;
  SI_SERVERCONF *sc_next;
  SI_SERVERCONF *sc_prev;
};

struct _si_moduleconf
{
  char *mc_name;
  char *mc_arg;
#define SI_MC_FLAGS_LOADED 0x001
  u_int mc_flags;
  SI_MODULECONF *mc_next;
  SI_MODULECONF *mc_prev;
};

struct _si_conf
{
  char *c_name;
  char *c_info;
  u_int c_flags;
  u_int c_timeout;
  SI_LISTENCONF *c_listeners;
  SI_SERVERCONF *c_servers;
  SI_MODULECONF *c_modules;
  SI_MODULECONF *c_lastmodule;
};

void siconf_free(SI_CONF *, void (*)(SI_LISTENCONF *));
int siconf_load(char *, SI_CONF **);
int siconf_parse(SI_CONF *, SI_CONF *, void (*)(SI_LISTENCONF *), void (*)(SI_LISTENCONF *));
SI_SERVERCONF *siconf_find_server(SI_CONF *, char *, struct sockaddr_in *);
SI_SERVERCONF *siconf_find_autoconn_server(SI_CONF *, time_t);

#endif
