/* MChanfix -- mempool.h
 * Copyright (C) 2004 MChanfix Development
 * $Id: mempool.h,v 1.2 2004/08/30 00:00:21 musirc Exp $
 */

#ifndef __MEMPOOL_H__
#define __MEMPOOL_H__

#include <sys/types.h>

#define SI_MEMPOOL_MAGIC 0x31337abc
typedef struct _si_mempool_entry SI_MEMPOOL_ENTRY;
typedef struct _si_mempool_pentry SI_MEMPOOL_PENTRY;
typedef struct _si_mempool SI_MEMPOOL;

struct _si_mempool_entry
{
  SI_MEMPOOL *e_mempool;
  u_int e_datalen;
  char e_data[1];
};

struct _si_mempool_pentry
{
  u_int pe_magic;
};

struct _si_mempool
{
  char *mp_name;
  SI_MEMPOOL_ENTRY *mp_entries;
#define SI_MEMPOOL_FLAGS_BOUNDSCHECK 0x001
  u_int mp_flags;
  int mp_num_entries;
  int mp_tot_used;
};

int simempool_init(SI_MEMPOOL *, char *, u_int);
void simempool_deinit(SI_MEMPOOL *);
void *simempool_alloc(SI_MEMPOOL *, u_int);
void *simempool_calloc(SI_MEMPOOL *, u_int, u_int);
char *simempool_strdup(SI_MEMPOOL *, char *);
void *simempool_realloc(SI_MEMPOOL *, void *, u_int);
void simempool_free(void *);
void simempool_check(SI_MEMPOOL *);
void simempool_dump(SI_MEMPOOL *);

#endif
