/* MChanfix -- queue.h
 * Copyright (C) 2004 MChanfix Development
 * $Id: queue.h,v 1.2 2004/08/30 00:00:21 musirc Exp $
 */

#ifndef __QUEUE_H__
#define __QUEUE_H__

#include <sys/types.h>

typedef struct _si_queue_entry SIQUEUE_ENTRY;
typedef struct _si_queue SIQUEUE;

struct _si_queue_entry
{
  char qe_buffer[16*1024];
  char *qe_addpos;
  char *qe_bufpos;
  SIQUEUE_ENTRY *qe_next;
};

struct _si_queue
{
  u_int q_size;
  SIQUEUE_ENTRY *q_tail;
  SIQUEUE_ENTRY *q_head;
};

#define siqueue_buflen(__x) ((__x)->q_size)

int siqueue_add(SIQUEUE *, char *, u_int);
int siqueue_del(SIQUEUE *, u_int);
int siqueue_get(SIQUEUE *, struct iovec *, u_int *);
void siqueue_free(SIQUEUE *);

#endif
