/*
**   line based config file parsing library -- csconfig.h
**   Copyright (C) 2001-2004 Chris Behrens
**
**   This program is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 1, or (at your option)
**   any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __CSCONFIG_H__
#define __CSCONFIG_H__

typedef void (*csc_error_cb_t)(u_int severity, char *error, char *filename, u_int lineno);
typedef int (*csc_cscc_cb_t)(void *csc_cookie, char *args, void **cb_arg);


typedef struct _csc_command	CSC_COMMAND;

struct _csc_command
{   
    char    		*cscc_name;
	csc_cscc_cb_t	cscc_cb;
    u_int   		cscc_flags;
    void    		*cscc_arg; 
};                   

#define CSC_SEVERITY_WARNING	1
#define CSC_SEVERITY_ERROR		2



char *csconfig_next_arg(char **args);
int csconfig_parse(char *buffer, CSC_COMMAND *commands, void *cb_arg, csc_error_cb_t error_cb);
int csconfig_read(char *filename, CSC_COMMAND *commands, void *cb_arg, csc_error_cb_t error_cb);
u_int csconfig_lineno(void *csc_cookie);
char *csconfig_filename(void *csc_cookie);
CSC_COMMAND *csconfig_command(void *csc_cookie);
void csconfig_error(void *csc_cookie, int severity, char *string);


#endif
